unit hiDirFileSize;

interface

uses Windows,Kol,Share,Debug;

type
  THIDirFileSize = class(TDebug)
   private
      Size,SSize:string;
      Idx,Dg:integer;
      procedure Convert;
   public
      _data_Path:THI_Event;
      _data_Source:THI_Event;       
      _data_Digits:THI_Event;
      _event_onSize:THI_Event;
      _event_onIdx:THI_Event;    
      _event_onSSize:THI_Event;    
      _prop_Digits:integer;
      procedure _work_doSize(var _Data:TData; Index:word);
      procedure _work_doConvert(var _Data:TData; Index:word);
      procedure _work_doDigits(var _Data:TData; Index:word);    
      procedure _var_Size(var _Data:TData; Index:word);
      procedure _var_Idx(var _Data:TData; Index:word);
      procedure _var_SSize(var _Data:TData; Index:word);        
  end;

implementation

function FileSize( const Path : String ) : Int64;
type T = record L,H:DWORD end;
var FD : TWin32FindData;
    FH : THandle;
begin
  FH := FindFirstFile( PChar( Path ), FD );
  Result := 0;
  if FH = INVALID_HANDLE_VALUE then exit;
  T(Result).L := FD.nFileSizeLow;
  T(Result).H := FD.nFileSizeHigh;
  FindClose( FH );
end;

procedure THIDirFileSize._work_doSize;
var fn:string;
    ED:integer;
begin
   fn := ReadString(_Data,_data_Path,'');
   Dg := ReadInteger(_Data,_data_Digits,_prop_Digits);
   if Dg = 0 then Dg := 10;
   ED := integer(DirectoryExists(fn));
   if ED = 1 then
    begin
      Size := Int64_2Str(DirectorySize(fn));   
      _hi_onEvent(_event_onSize,Size);
      Convert;
    end 
      else 
    begin
      Size := Double2Str(FileSize(fn));
      _hi_onEvent(_event_onSize,Size);
      Convert;
    end;
end;

procedure THIDirFileSize.Convert;
var Sz,r:real;
    i:byte;
begin
   Sz := Str2Double(Size);
   if Sz < 1000 then i:= 0 else 
   if Sz < 1000000 then i:= 1 else
   if Sz < 1000000000 then i:= 2 else i:=3;
   Idx := i;
   _hi_onEvent(_event_onIdx,Idx);

   r:= 0;
   case idx of
      0: r:= Sz;
      1: r:= Sz/1024;
      2: r:= Sz/1048576;
      3: r:= Round(Sz) div 1024/1048576;
   end;
   r:= Trunc(r) + round((r - Trunc(r))*Dg)/Dg;
   SSize := Double2Str(r);
   _hi_onEvent(_event_onSSize,SSize); 
end;

procedure THIDirFileSize._work_doConvert;
begin
   Size := ReadString(_Data,_data_Source,'');
   Dg := ReadInteger(_Data,_data_Digits,_prop_Digits);
   if Dg = 0 then Dg := 10;
   Convert;
end;

procedure THIDirFileSize._work_doDigits;
begin
   _prop_Digits := ToInteger(_Data);
end;

procedure THIDirFileSize._var_Size(var _Data:TData; Index:word);
begin
   dtString(_Data,Size);
end;

procedure THIDirFileSize._var_Idx(var _Data:TData; Index:word);
begin
   dtInteger(_Data,Idx);
end;

procedure THIDirFileSize._var_SSize(var _Data:TData; Index:word);
begin
   dtString(_Data,SSize);
end;

end.